/**
* DevExtreme (file_management/remote_provider.d.ts)
* Version: 20.1.4 (build 20169-1806)
* Build date: Wed Jun 17 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import FileSystemProviderBase, {
    FileSystemProviderBaseOptions
} from './provider_base';

/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface RemoteFileSystemProviderOptions extends FileSystemProviderBaseOptions<RemoteFileSystemProvider> {
   /** Specifies the URL of an endpoint used to access and modify a file system located on the server. */
    endpointUrl?: string;
   /** Specifies which data field provides information about whether a directory has subdirectories. */
    hasSubDirectoriesExpr?: string | Function;
}/** The Remote file system provider works with a file system located on the server. */
export default class RemoteFileSystemProvider extends FileSystemProviderBase {
    constructor(options?: RemoteFileSystemProviderOptions)
}
